/**
 * params.js
 */
export type cipherTypes = 'AES-GCM' | 'AES-CBC' | 'AES-CTR' | 'AES-KW';
export interface cipherOptions {
    name: cipherTypes;
    iv?: Uint8Array;
    additionalData?: Uint8Array;
    tagLength?: number;
}
export interface cipherParams {
    nodePrefix: string;
    nodeSuffix: string;
    ivLength?: number;
    tagLength?: number;
    staticIvLength: boolean;
    defaultIv?: Uint8Array;
}
declare const _default: {
    ciphers: {
        [index: string]: cipherParams;
    };
    wrapKeys: {
        [index: string]: cipherParams;
    };
};
export default _default;
